from Tkinter import *
from ATOM3Type import *
from ATOM3Integer import *
from ATOM3String import *
from ATOM3Appearance import *
class widthXfillXdecoration (ATOM3Type):
   def __init__(self):
      ATOM3Type.__init__(self)
      self.width= None
      self.fill= None
      self.decoration= None
      self.decoration_Position = None

   def createComponents(self):
      if not self.width:
         self.width=ATOM3Integer(0)
      if not self.fill:
         self.fill=ATOM3String('')
      if not self.decoration:
         self.decoration=ATOM3Appearance()
         self.decoration.setValue( ('class0', self))
      if not self.decoration_Position:
         self.decoration_Position=ATOM3Enum(['Up', 'Down', 'Middle', 'No decoration'], 3)

   def show(self, parent, parentWindowInfo=None):
      self.createComponents()
      ATOM3Type.show(self, parent, parentWindowInfo)
      self.containerFrame = Frame(parent)
      Label(self.containerFrame, text='width').grid(row=0,column=0,sticky=W)
      self.width.show(self.containerFrame, parentWindowInfo).grid(row=0,column=1,sticky=W)
      Label(self.containerFrame, text='fill').grid(row=1,column=0,sticky=W)
      self.fill.show(self.containerFrame, parentWindowInfo).grid(row=1,column=1,sticky=W)
      Label(self.containerFrame, text='decoration').grid(row=2,column=0,sticky=W)
      self.decoration.show(self.containerFrame, parentWindowInfo).grid(row=2,column=1,sticky=W)
      Label(self.containerFrame, text='decoration_Position').grid(row=3,column=0,sticky=W)
      self.decoration_Position.show(self.containerFrame, parentWindowInfo).grid(row=3,column=1,sticky=W)

      return self.containerFrame

   def toString(self):
      self.createComponents()
      return  self.width.toString()+' '+ self.fill.toString()+' '+ self.decoration.toString()+' '+ self.decoration_Position.toString()

   def getValue(self):
      self.createComponents()
      return (self.width.getValue(),self.fill.getValue(),self.decoration.getValue(),self.decoration_Position.getValue(),)

   def setValue(self, value):
      self.createComponents()
      if value == None:
         self.width.setNone()
         self.fill.setNone()
         self.decoration.setNone()
         self.decoration_Position.setNone()
      else:
         self.width.setValue(value[0])
         self.fill.setValue(value[1])
         self.decoration.setValue(value[2])
         self.decoration_Position.setValue(value[3])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      self.createComponents()
      file.write(indent+objName+'= widthXfillXdecoration()\n')
      self.width.writeConstructor2File(file, indent, objName+'.width', depth, generatingCode)
      self.fill.writeConstructor2File(file, indent, objName+'.fill', depth, generatingCode)
      self.decoration.writeConstructor2File(file, indent, objName+'.decoration', depth, generatingCode)
      self.decoration_Position.writeConstructor2File(file, indent, objName+'.decoration_Position', depth, generatingCode)

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      self.createComponents()
      self.width.writeValue2File(file, indent, objName+'.width', depth, generatingCode)
      self.fill.writeValue2File(file, indent, objName+'.fill', depth, generatingCode)
      self.decoration.writeValue2File(file, indent, objName+'.decoration', depth, generatingCode)
      self.decoration_Position.writeValue2File(file, indent, objName+'.decoration_Position', depth, generatingCode)

   def clone(self):
     "Makes an exact copy of itself"
     cloneObject = widthXfillXdecoration()
     if self.width: cloneObject.width = self.width.clone()
     if self.fill: cloneObject.fill = self.fill.clone()
     if self.decoration: cloneObject.decoration = self.decoration.clone()
     if self.decoration_Position: cloneObject.decoration_Position = self.decoration_Position.clone()
     return cloneObject
   def destroy(self):
     "Destroys (i.e. updates) each field"
     cloneObject = widthXfillXdecoration()
     if self.width: self.width.destroy()
     if self.fill: self.fill.destroy()
     if self.decoration: self.decoration.destroy()
     if self.decoration_Position: self.decoration_Position.destroy()
     return cloneObject

   def copy(self, other):
      ATOM3Type.copy(self, other)
      self.width = other.width
      self.fill = other.fill
      self.decoration = other.decoration
      self.decoration_Position = other.decoration_Position

   def invalid(self):
      # this was missing! (added 15 Jan 2002)
      return self.width.invalid() or self.fill.invalid() or self.decoration.invalid() or self.decoration_Position.invalid()




