# __Block.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3String import *
from ATOM3Float import *
from ATOM3Port import *
from ATOM3Enum import *
from graph_Block import *
class Block(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_Block
      self.parent = parent
      self.block_name=ATOM3String('')
      self.block_out_value=ATOM3Float(0.0)
      self.block_tmp_value=ATOM3Float(0.0)
      self.block_out_port = []
      self.block_IC_port = []
      self.block_type=ATOM3Enum(['Generic', 'Negator', 'Inverter', 'Adder', 'Product', 'Delay', 'Integrator', 'Derivative', 'Constant', 'Time'], 0, 0)
      self.block_operator=ATOM3String('')
      self.generatedAttributes = {'block_name': ('ATOM3String', ),
                                  'block_out_value': ('ATOM3Float', ),
                                  'block_tmp_value': ('ATOM3Float', ),
                                  'block_type': ('ATOM3Enum', ),
                                  'block_operator': ('ATOM3String', )      }
      self.realOrder = ['block_name','block_out_value','block_tmp_value','block_type','block_operator']
   def clone(self):
      cloneObject = Block( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.EDIT or actionID == self.CREATE:
         res = self.changeIcon(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def changeIcon(self, params):
      if self.parent.editGGLabel: return
      tval =self.block_type.getValue()
      tname=tval[0][tval[1]]
      cx, cy = self.graphObject_.x, self.graphObject_.y
      oldObject = self.graphObject_
      if tname == 'Generic':
         from graph_Block import *
         self.graphObject_=graph_Block(cx, cy, self)
      elif tname == 'Negator':
         from graph_Negator import *
         self.graphObject_=graph_Negator(cx, cy, self)
      elif tname == 'Inverter':
         from graph_Inverter import *
         self.graphObject_=graph_Inverter(cx, cy, self)
      if tname == 'Adder':
         from graph_Adder import *
         self.graphObject_=graph_Adder(cx, cy, self)
      elif tname == 'Product':
         from graph_Product import *
         self.graphObject_=graph_Product(cx, cy, self)
      elif tname == 'Delay':
         from graph_Delay import *
         self.graphObject_=graph_Delay(cx, cy, self)
      elif tname == 'Integrator':
         from graph_Integrator import *
         self.graphObject_=graph_Integrator(cx, cy, self)
      elif tname == 'Derivative':
         from graph_Derivative import *
         self.graphObject_=graph_Derivative(cx, cy, self)
      elif tname == 'Constant':
         from graph_Constant import *
         self.graphObject_=graph_Constant(cx, cy, self)
      elif tname == 'Time':
         from graph_Time import *
         self.graphObject_=graph_Time(cx, cy, self)
      self.graphObject_.connections = []+oldObject.connections
      oldObject.erase(self.parent,0)
      self.graphObject_.DrawObject(self.parent.UMLmodel, self.parent.editGGLabel)
      self.parent.UMLmodel.addtag_withtag("Block", self.graphObject_.tag)
      self.graphObject_.semanticObject = oldObject.semanticObject
      
      
      
      
      
      
      
      



