# __Plot.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from graph_Plot import *
class Plot(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_Plot
      self.parent = parent
      self.generatedAttributes = {      }
      self.realOrder = []
   def clone(self):
      cloneObject = Plot( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.DRAG:
         res = self.openWindow(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def openWindow(self, params):
      import MODEL_plotWindow
      MODEL_plotWindow.plotWindow(self)
      
      
      
      



