# __LeafType.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3Attribute import *
from ATOM3Constraint import *
from graph_LeafType import *
class LeafType(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_LeafType
      self.parent = parent
      self.Type=ATOM3Attribute(parent.types)
      self.Type.setValue(('ltypename', 'String', None, ('Key', 0), ('Direct Editing', 1)))
      self.Type.initialValue=ATOM3String('')
      self.TypeConstraint=ATOM3Constraint()
      self.TypeConstraint.setValue(('typeConst', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n\n'))
      self.generatedAttributes = {'Type': ('ATOM3Attribute', ),
                                  'TypeConstraint': ('ATOM3Constraint', )      }
   def show(self, parent, parentWindowInfo):
      ATOM3Type.show(self, parent, parentWindowInfo)
      self.containerFrame = Frame(parent)
      Label(self.containerFrame, text='Type').grid(row=0,column=0,sticky=W)
      self.Type.show(self.containerFrame, parentWindowInfo).grid(row=0,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'Type', 0, 2)
      Label(self.containerFrame, text='TypeConstraint').grid(row=1,column=0,sticky=W)
      Button( self.containerFrame, text = 'edit', command =  lambda x=self : ATOM3TypeDialog(x.containerFrame, x.TypeConstraint)).grid(row=1,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'TypeConstraint', 1, 2)
      ASGNode.editGGLabel(self, self.containerFrame, parentWindowInfo, 2)
      return self.containerFrame

   def toString(self, maxWide = None, maxLines = None ):
      rs = self.Type.toString()+' '+self.TypeConstraint.toString()
      if maxWide: return self.strValue[0:maxWide-3]+'...'
      else: return rs


   def getValue(self):
      return (self.Type.getValue(),self.TypeConstraint.getValue(),)

   def setValue(self, value):
      self.Type.setValue(value[0])
      self.TypeConstraint.setValue(value[1])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the constructor and the value of the object. Must be overriden in children"
      self.Type.writeConstructor2File(file, indent, objName+'.Type', depth, generatingCode)
      self.TypeConstraint.writeConstructor2File(file, indent, objName+'.TypeConstraint', depth, generatingCode)

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the the value of the object. Must be overriden in children"
      self.Type.writeValue2File(file, indent, objName+'.Type', depth, generatingCode)
      self.TypeConstraint.writeValue2File(file, indent, objName+'.TypeConstraint', depth, generatingCode)

   def invalid(self):
      ASGNode.GGcheckSetNone(self)
      return self.Type.invalid() or self.TypeConstraint.invalid() 

   def clone(self):
      cloneObject = LeafType( self.parent )
      cloneObject.Type = self.Type.clone()
      cloneObject.TypeConstraint = self.TypeConstraint.clone()
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      self.Type = other.Type
      self.TypeConstraint = other.TypeConstraint
      ASGNode.copy(self, other)

   def destroy(self):
      ASGNode.GGcheckSetNone(self)
      self.Type.destroy()
      self.TypeConstraint.destroy()
      self.containerFrame = None
   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None


