# __Operator.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3Enum import *
from graph_Operator import *
class Operator(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_Operator
      self.parent = parent
      self.type=ATOM3Enum(['X', 'U', '->'], 0, 0)
      self.generatedAttributes = {'type': ('ATOM3Enum', )      }
   def show(self, parent, parentWindowInfo):
      ATOM3Type.show(self, parent, parentWindowInfo)
      self.containerFrame = Frame(parent)
      Label(self.containerFrame, text='type').grid(row=0,column=0,sticky=W)
      self.type.show(self.containerFrame, parentWindowInfo).grid(row=0,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'type', 0, 2)
      ASGNode.editGGLabel(self, self.containerFrame, parentWindowInfo, 1)
      return self.containerFrame

   def toString(self, maxWide = None, maxLines = None ):
      rs = self.type.toString()
      if maxWide: return self.strValue[0:maxWide-3]+'...'
      else: return rs


   def getValue(self):
      return (self.type.getValue(),)

   def setValue(self, value):
      self.type.setValue(value[0])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the constructor and the value of the object. Must be overriden in children"
      self.type.writeConstructor2File(file, indent, objName+'.type', depth, generatingCode)

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the the value of the object. Must be overriden in children"
      self.type.writeValue2File(file, indent, objName+'.type', depth, generatingCode)

   def invalid(self):
      ASGNode.GGcheckSetNone(self)
      return self.type.invalid() 

   def clone(self):
      cloneObject = Operator( self.parent )
      cloneObject.type = self.type.clone()
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      self.type = other.type
      ASGNode.copy(self, other)

   def destroy(self):
      ASGNode.GGcheckSetNone(self)
      self.type.destroy()
      self.containerFrame = None
   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None


