# _ TupleGen.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from ASG_TypesMetaModel import *
from Operator import *
from TypeName import *
from LeafType import *
class TupleGen (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 1)
      self.LHS = ASG_TypesMetaModel(parent)

      self.obj22=Operator(parent)

      self.obj22.type.setValue( (['X', 'U', '->'], 0) )
      self.obj22.type.config = 0
      self.obj22.GGLabel.setValue(1)
      self.obj22.graphClass_= graph_Operator
      if parent.genGraphics:
         from graph_Operator import *
         new_obj = graph_Operator(208.0,271.0,self.obj22)
      else: new_obj = None
      self.obj22.graphObject_ = new_obj
      self.LHS.addNode(self.obj22)
      self.RHS = ASG_TypesMetaModel(parent)

      self.obj24=Operator(parent)

      self.obj24.type.setValue( (['X', 'U', '->'], 0) )
      self.obj24.type.config = 0
      self.obj24.GGLabel.setValue(1)
      self.obj24.graphClass_= graph_Operator
      if parent.genGraphics:
         from graph_Operator import *
         new_obj = graph_Operator(205.0,255.0,self.obj24)
      else: new_obj = None
      self.obj24.graphObject_ = new_obj
      self.obj240= AttrCalc()
      self.obj240.Copy=ATOM3Boolean()
      self.obj240.Copy.setValue(('Copy from LHS', 1))
      self.obj240.Copy.config = 0
      self.obj240.Specify=ATOM3Constraint()
      self.obj240.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj24.GGset2Any['type']= self.obj240
      self.RHS.addNode(self.obj24)
   def condition(self, graphID, isograph, atom3i):
      node = self.getMatched(graphID, self.LHS.nodeWithLabel(1))
      if node.FILE_: 		# This node has been processed yet!
        return 0
      self.generatedChilds = []
      for child in node.out_connections_:# childs have the FILE_ slot filled...
        if child.FILE_:	# if this is the case, add to list
           self.generatedChilds.append(child)
        else:
           return 0	        # otherwise, the condition does not hold...
      return 1		
      
      
      
      

   def action(self, graphID, isograph, atom3i):
      "action performed when the rule is applied "
      nnode = self.getMatched(graphID, self.LHS.nodeWithLabel(1))
      # compose the class name
      className = ""
      counter = 0
      attributesInfo = []							# list to be passed to the generateCode4Product function
      for node in self.generatedChilds:					# for each child that has been found...
         if counter > 0: className = className+"X"
         if node.getClass() == 'LeafType':
            className = className + node.Type.getValue()[0]		# append the name of the element
            val = node.Type.getValue()
            attributesInfo.append((val[0], 'ATOM3'+val[1], val[2], node))
         else:
            className = className + node.FILE_
            attributesInfo.append((node.FILE_, node.FILE_, None, node))
         counter = counter + 1
      print "performing action! className = ", className
      nnode.FILE_=className
      fileName = className+".py"
      file = open(atom3i.codeGenDir +"/"+fileName, "w+t")			
      file.write("from Tkinter import *\n")					
      file.write("from ATOM3Type import *\n")
      # generate imports...
      for element in attributesInfo:					# for each element in attributesInfo...
         name, type, valInitial, node = element                         # unpack element components
         file.write("from "+type+" import *\n")
      file.write("class "+className+" (ATOM3Type):\n")
      file.write("   def __init__(self):\n")
      # .........................................................
      # Generate the __init__ method
      # .........................................................
      file.write("      ATOM3Type.__init__(self)\n")
      for element in attributesInfo:					# for each element in attributesInfo...
         name, type, valInitial, node = element                         # unpack element components
         file.write("      self."+name+"= None\n")			# for the moment, initialize to None...
      file.write("\n")
      # .........................................................
      # Generate the createComponents method
      # .........................................................
      file.write("   def createComponents(self):\n")
      for element in attributesInfo:					# for each element in attributesInfo...
         name, type, valInitial, node = element                         # unpack element components
         file.write("      if not self."+name+":\n")
         if node.getClass() == 'LeafType':                               # we are dealing with a simple type...
             node.Type.initialValue.writeConstructor2File(file,"         ", "self."+name, 0, 1)
         else:
             file.write("         from "+name+" import *\n")		# import the class...
             file.write("         self."+name+"="+type+"()\n")
      file.write("\n")
      # .........................................................
      # Generate the show method
      # .........................................................
      file.write("   def show(self, parent, parentWindowInfo=None):\n")
      file.write("      self.createComponents()\n")
      file.write("      ATOM3Type.show(self, parent, parentWindowInfo)\n")
      file.write("      self.containerFrame = Frame(parent)\n")
      counter = 0
      for element in attributesInfo:					# for each element in attributesInfo...
         name, type, valInitial, node = element                         # unpack element components
         if node.getClass() == "LeafType":
            directEditing = node.Type.getValue()[4][1]
         else:
            directEditing = 1
         file.write("      Label(self.containerFrame, text='"+name+"').grid(row="+str(counter)+",column=0,sticky=W)\n")
         if directEditing:
            file.write("      self."+name+".show(self.containerFrame, parentWindowInfo).grid(row="+str(counter)+",column=1,sticky=W)\n")
         else:
            file.write("      Button( self.containerFrame, text = 'edit', ")
            file.write("command =  lambda x=self : ATOM3TypeDialog(x.containerFrame, x."+name+"))")
            file.write(".grid(row="+str(counter)+",column=1,sticky=W)\n")
         counter = counter + 1
      file.write("      return self.containerFrame\n\n")
      # .........................................................
      # Generate the toString method
      # .........................................................
      file.write("   def toString(self):\n")
      file.write("      self.createComponents()\n")
      file.write("      return ")
      counter = 0
      for element in attributesInfo:					# for each element in attributesInfo...
         name, type, valInitial, node = element                         # unpack element components
         if counter: file.write("+' '+")
         file.write(" self."+name+".toString()")
         counter = counter + 1
      file.write("\n")
      # .........................................................
      # Generate the getValue method
      # .........................................................
      file.write("   def getValue(self):\n")
      file.write("      self.createComponents()\n")
      file.write("      return (")
      for element in attributesInfo:					# for each element in attributesInfo...
         name, type, valInitial, node = element                         # unpack element components
         file.write("self."+name+".getValue(),")
      file.write(")\n\n")
      # .........................................................
      # Generate the setValue method
      # .........................................................
      file.write("   def setValue(self, value):\n")
      file.write("      self.createComponents()\n")
      file.write("      if value == None:\n")
      for element in attributesInfo:					# for each element in attributesInfo...
         name, type, valInitial, node = element                         # unpack element components
         file.write("         self."+name+".setNone()\n")
      file.write("      else:\n")
      counter = 0
      for element in attributesInfo:					# for each element in attributesInfo...
         name, type, valInitial, node = element                         # unpack element components
         file.write("         self."+name+".setValue(value["+str(counter)+"])\n")
         counter = counter + 1
      file.write("\n")
      # .........................................................
      # Generate the writeConstructor2File method
      # .........................................................
      file.write('   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):\n')
      file.write("      self.createComponents()\n")
      file.write("      file.write(indent+objName+'= "+className+"()\\n')\n")
      for element in attributesInfo:					# for each element in attributesInfo...
         name, type, valInitial, node = element                         # unpack element components
         file.write("      self."+name+".writeConstructor2File(file, indent, objName+'."+name+"', depth, generatingCode)\n")
      file.write("\n")
      # .........................................................
      # Generate the writeValue2File method
      # .........................................................
      file.write('   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):\n')
      file.write("      self.createComponents()\n")
      for element in attributesInfo:					# for each element in attributesInfo...
        name, type, valInitial, node = element                         # unpack element components
        file.write("      self."+name+".writeValue2File(file, indent, objName+'."+name+"', depth, generatingCode)\n")
      file.write("\n")
      # .........................................................
      # Generate the clone method
      # .........................................................
      file.write('   def clone(self):\n')
      file.write('     "Makes an exact copy of itself"\n')
      file.write('     cloneObject = '+className+'()\n')
      for element in attributesInfo:					# for each element in attributesInfo...
         name, type, valInitial, node = element                         # unpack element components
         file.write('     if self.'+name+': cloneObject.'+name+' = self.'+name+'.clone()\n')
      file.write('     return cloneObject\n')
      # .........................................................
      # Generate the destroy method
      # .........................................................
      file.write('   def destroy(self):\n')
      file.write('     "Destroys (i.e. updates) each field"\n')
      file.write('     cloneObject = '+className+'()\n')
      for element in attributesInfo:					# for each element in attributesInfo...
         name, type, valInitial, node = element                         # unpack element components
         file.write('     if self.'+name+': self.'+name+'.destroy()\n')
      file.write('     return cloneObject\n')
      # .........................................................
      # Generate the invalid method
      # .........................................................
      file.write('   def invalid(self):\n')
      file.write('     "checks whether the entity is valid or not"\n')
      file.write('     inval = 0\n')
      for element in attributesInfo:					# for each element in attributesInfo...
         name, type, valInitial, node = element                         # unpack element components
         file.write('     if self.'+name+': inval = inval or self.'+name+'.invalid()\n')   
      file.write('     return inval\n\n')
      file.close()
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      

