# __TypeName.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3String import *
from graph_TypeName import *
class TypeName(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_TypeName
      self.parent = parent
      self.Name=ATOM3String('typename')
      self.keyword_= self.Name
      self.generatedAttributes = {'Name': ('ATOM3String', )      }
   def show(self, parent, parentWindowInfo):
      ATOM3Type.show(self, parent, parentWindowInfo)
      self.containerFrame = Frame(parent)
      Label(self.containerFrame, text='Name').grid(row=0,column=0,sticky=W)
      self.Name.show(self.containerFrame, parentWindowInfo).grid(row=0,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'Name', 0, 2)
      ASGNode.editGGLabel(self, self.containerFrame, parentWindowInfo, 1)
      return self.containerFrame

   def toString(self, maxWide = None, maxLines = None ):
      rs = self.Name.toString()
      if maxWide: return self.strValue[0:maxWide-3]+'...'
      else: return rs


   def getValue(self):
      return (self.Name.getValue(),)

   def setValue(self, value):
      self.Name.setValue(value[0])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the constructor and the value of the object. Must be overriden in children"
      self.Name.writeConstructor2File(file, indent, objName+'.Name', depth, generatingCode)

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the the value of the object. Must be overriden in children"
      self.Name.writeValue2File(file, indent, objName+'.Name', depth, generatingCode)

   def invalid(self):
      ASGNode.GGcheckSetNone(self)
      return self.Name.invalid() 

   def clone(self):
      cloneObject = TypeName( self.parent )
      cloneObject.Name = self.Name.clone()
      cloneObject.keyword_ = cloneObject.Name
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      self.Name = other.Name
      self.keyword_ = self.Name
      ASGNode.copy(self, other)

   def destroy(self):
      ASGNode.GGcheckSetNone(self)
      self.Name.destroy()
      self.containerFrame = None
   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.EDIT:
         res = self.validName(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def validName(self, params):
      import string
      vname = self.Name.getValue()
      # check if we have a name
      if (not vname) or (vname == ""):                 # the name is mandatory
         return "Entity name must be specified", ""
      # now check that the name is valid (a variable name)
      if string.count(vname, " ") > 0:
         return "Invalid entity name, no white spaces allowed",""
      # check first character
      if (vname[0] >= '0') and (vname[0] <= '9'):              # a number
         return "Invalid variable name, first character must be a letter or '_'",""
      if vname[0] != '_' and (vname[0]<'A' or vname[0]>'z'):
         return "Invalid entity name, first character must be a letter or '_'",""
      # now check for the rest of not allowed characters...
      for c in range(len(vname)-1):
       if vname[c+1] < 'A' or vname[c+1] > 'z':              # not a letter
        if vname[c+1] < '0' or vname[c+1] > '9':           # not a number
         if vname[c+1] != '_':                                # not underscore
          return "Invalid entity name, character '"+vname[c+1]+"' is not allowed",""
      
      
      
      



